<?php
/*
Plugin Name: Posts in the Same Month and Last Year Widget
Plugin URI: http://www.blogshh.securehostinghawaii.com/wordpress/
Author: Eli Scheetz
Author URI: http://wordpress.ieonly.com/category/my-plugins/smaly-widget/
Contributors: scheeeli, mauideveloper
Donate link: https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=8VWNB5QEJ55TJ
Description: This Widget lists and links to any posts posted in the current month of the prior year. If you don't have any posts posted in the current month of the prior year it will not show the widget at all.
Version: 1.2.04.04
*/
$SMALY_Version='1.2.04.04';
$_SESSION['eli_debug_microtime']['include(SMALY)'] = microtime(true);
/**
 * SMALY Main Plugin File
 * @package SMALY
*/
/*  Copyright 2011 Eli Scheetz (email: wordpress@ieonly.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
function SMALY_install() {
	global $wp_version;
$_SESSION['eli_debug_microtime']['SMALY_install_start'] = microtime(true);
	if (version_compare($wp_version, "2.6", "<"))
		die(__("This Plugin requires WordPress version 2.6 or higher"));
$_SESSION['eli_debug_microtime']['SMALY_install_end'] = microtime(true);
}
class SMALY_Widget_Class extends WP_Widget {
	function SMALY_Widget_Class() {
$_SESSION['eli_debug_microtime']['SMALY_Widget_Class_Widget_Class_start'] = microtime(true);
		$this->WP_Widget('SMALY-Widget', __('This Month Last Year'), array('classname' => 'widget_SMALY', 'description' => __('List and link to any posts posted in the current month of the prior year')));
		$this->alt_option_name = 'widget_SMALY';
$_SESSION['eli_debug_microtime']['SMALY_Widget_Class_Widget_Class_end'] = microtime(true);
	}
	function widget($args, $instance) {
		global $wp_query, $posts, $post;
$_SESSION['eli_debug_microtime']['_Widget_Class_widget_start'] = microtime(true);
		$LIs = '';
		extract($args);
		if (!$instance['title'])
			$instance['title'] = "This Month Last Year";
		if (!$instance['excerpt'])
			$instance['excerpt'] = "yes";
		if (!is_numeric($instance['number']))
			$instance['number'] = 5;
		if ($instance['number'] > 0) {
			$day = date('j');
			$w = date('W');
			$monthnum = date('n');
			$year = date('Y')-1;
			$SMALY_query = new WP_Query(array('showposts' => $instance['number'], 'year' => $year, 'monthnum' => $monthnum, 'orderby' => 'rand', 'order' => 'ASC'));
			while ( $SMALY_query->have_posts() ) {
				$SMALY_query->the_post();
				$LIs .= the_title('<li class="SMALY-Post"><a title="', '" href="', false).get_permalink($post->ID).the_title('" rel="bookmark">', "</a></li>\n", false);
			}
			wp_reset_postdata();
		}
		if (strlen($LIs) > 0)
			echo $before_widget.$before_title.$instance["title"].$after_title."<ul class=\"SMALY-Posts\">\n".$LIs."</ul>\n".$after_widget;
//else echo 'no li';
$_SESSION['eli_debug_microtime']['SMALY_Widget_Class_widget_end'] = microtime(true);
	}
	function flush_widget_cache() {
		wp_cache_delete('widget_SMALY', 'widget');
	}
	function update($new, $old) {
		$instance = $old;
		$instance['title'] = strip_tags($new['title']);
		$instance['number'] = (int) $new['number'];
		$instance['excerpt'] = strip_tags($new['excerpt']);
		return $instance;
	}
	function form( $instance ) {
$_SESSION['eli_debug_microtime']['SMALY_Widget_Class_form_start'] = microtime(true);
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$excerpt = isset($instance['excerpt']) ? esc_attr($instance['excerpt']) : 'yes';
		echo '<p><label for="'.$this->get_field_id('title').'">'.__('Alternate Widget Title').':</label>
		<input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$title.'" /></p>
		<p><label for="'.$this->get_field_id('number').'">Max Number of Posts to Show:</label>
		<input type="text" size="2" name="'.$this->get_field_name('number').'" id="'.$this->get_field_id('number').'" value="'.$number.'" /></p>';
//		<p><label for="'.$this->get_field_id('excerpt').'">'.__('Show Excerpts').':</label>
//		<input type="checkbox" name="'.$this->get_field_name('excerpt').'" id="'.$this->get_field_id('excerpt').'" value="yes"'.($excerpt=="yes"?" checked":"").' />yes</p>
$_SESSION['eli_debug_microtime']['SMALY_Widget_Class_form_end'] = microtime(true);
	}
}
register_activation_hook(__FILE__,'SMALY_install');
add_action('widgets_init', create_function('', 'return register_widget("SMALY_Widget_Class");'));
$_SESSION['eli_debug_microtime']['end_include(SMALY)'] = microtime(true);
?>
